--/////SET VAR
local titleColor = "|cff00ffff"
local cyan = "|cff00ffff"
local white = "|cffffffff"
local grey = "|cff888888"
local green = "|cff00ff00"
local red = "|cffff0000"
local fontSize = 17
local stringsToDisplay = {}

local title = "Recipe searching"

local labelsFrames = {}
local AllEventHandlers = {}
local playerName = UnitName("player");
local result = {}
--/////SET VAR FIN

local function in_array(val, tab)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end

function resetEntries()
	local j = GetNumTradeSkills()
	local previousSubclass = nil
	
	for i = 1, j do
		local skillName, skillType, _, _, _, _, _, _, _, _, _ = GetTradeSkillInfo(i)
		if skillName ~= nil and skillType == "header" then 
			local previousSubClassName, _, _, isExpanded, _, _, _, _, _, _, _ = GetTradeSkillInfo(i)
			if isExpanded == nil then
				ExpandTradeSkillSubClass(i)
				resetEntries()
				return
			end
		end
	end
end

local function searchEntry(term)
	wipe(result)
	local j = GetNumTradeSkills()
	for i = 1, j do
		local skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps, indentLevel, showProgressBar, currentRank, maxRank, startingRank = GetTradeSkillInfo(i)
		if skillName ~= nil and skillType ~= "header" and string.find(string.lower(skillName), string.lower(term)) then 
			table.insert(result, i)
		end
	end

	if result[1] == nil then return false else return result end
end

function searchEntryAndCollapseIfEmpty(term)
	local entries = searchEntry(term)
	--Si pas de result on va pas plus loin
	if entries == false then return entries end
	
	local j = GetNumTradeSkills()
	local previousSubclass = nil
	
	--On parcourt toutes les lignes
	for i = 1, j do
		local skillName, skillType, _, _, _, _, _, _, _, _, _ = GetTradeSkillInfo(i)

		--Si c'est un header et si on a le header d'avant alors on a une range on regarde si on a une entry dans cette range sinon on collapse le header d'avant
		if skillName ~= nil then 
			if skillType == "header" then
				if previousSubclass ~= nil then
					local previousSubClassName, _, _, isExpanded, _, _, _, _, _, _, _ = GetTradeSkillInfo(previousSubclass)
					local visible = false
					
					for ii = 1, #entries do
						if (entries[ii] > previousSubclass and entries[ii] < i) then
							visible = true
						end
					end
					if visible == false and isExpanded ~= nil then
						CollapseTradeSkillSubClass(previousSubclass)
						entries = searchEntryAndCollapseIfEmpty(term)

						return entries						
					end
				end
				previousSubclass = i
			end
			--Si c'est la dernière ligne on vérifie si depuis la dernière catégorie on une entrie sinon on collapse
			if (i == j and previousSubclass ~= nil) then
				local previousSubClassName, _, _, isExpanded, _, _, _, _, _, _, _ = GetTradeSkillInfo(previousSubclass)
				local visible = false
				for ii = 1, #entries do
					if (entries[ii] > previousSubclass and (entries[ii] < i or entries[ii] == i)) then
						visible = true
					end
				end
				if visible == false then
					CollapseTradeSkillSubClass(previousSubclass)
				end
			end
		end
	end

	return entries
end

--/////CREATE MAIN FRAME
--local firstFrame = CreateFrame('Button', 'MyButtonName', UIParent)
local firstFrame = CreateFrame("Frame", nil, UIParent)
local searchFrame = nil
--/////CREATE MAIN FRAME FIN

--/////EVENT
function AllEventHandlers:TRADE_SKILL_SHOW()
	if searchFrame == nil then searchFrame = CreateFrame("EditBox", nil, TradeSkillFrame, "InputBoxTemplate") end
	searchFrame:SetSize(90, 18)
	searchFrame:SetPoint("TOPLEFT",70,-15)
	searchFrame:SetAutoFocus(false)
	searchFrame:SetText(grey.."Search")
	searchFrame:Show()
	
	searchFrame:SetScript("OnEditFocusGained", function(self)
		self:SetText("")
	end)
	searchFrame:SetScript("OnEditFocusLost", function(self)
		self:SetText(grey.."Search")
	end)
	searchFrame:SetScript("OnTextChanged", function(self)
		
	end)
	searchFrame:SetScript("OnEnterPressed", function(self)
		local term = self:GetText()
		
		resetEntries()--Pour effectuer la recherche sur toutes les lignes
		local entries = searchEntryAndCollapseIfEmpty(term)

		if entries == false then
			print(cyan .. title .. " - " .. red .. "Term not found")
			local t = self:GetText()
			self:ClearFocus()
			self:SetText(red..t)
		else
			local t = self:GetText()
			self:ClearFocus()
			self:SetText(t)
			SelectTradeSkill(entries[1])
			SetTradeSkillInvSlotFilter(0,0,0);
		end
	end)
end

function AllEventHandlers:TRADE_SKILL_CLOSE(self)
	searchFrame:ClearFocus()
	searchFrame:SetText(grey.."Search")
	searchFrame:Hide()
end

--/////EVENT ON EACH LOADING
function AllEventHandlers:PLAYER_ENTERING_WORLD (...)

end

--/////OnUpdate EVENT WHO PROC ON EACH FRAME IG
firstFrame : SetScript ("OnUpdate", function ( self , event , ...)
	
end)

--/////REGISTER EVENTS
firstFrame : SetScript ("OnEvent", function ( self , event , ...)
	AllEventHandlers[event](self, ...)
end)

for event, _ in pairs (AllEventHandlers) do
	firstFrame:RegisterEvent(event)
end